package Scanner;/* The following code was generated by JFlex 1.6.1 */

/**
 * This class is a scanner generated by 
 * <a href="http://www.jflex.de/">JFlex</a> 1.6.1
 * from the specification file <tt>Scanner.flex</tt>
 */
public class FlexScanner implements Symbols {

    /**
     * This character denotes the end of file
     */
    public static final int YYEOF = -1;
    /**
     * lexical states
     */
    public static final int YYINITIAL = 0;
    public static final int STRING = 2;
    public static final int CHARLITERAL = 4;
    /**
     * initial size of the lookahead buffer
     */
    private static final int ZZ_BUFFERSIZE = 16384;
    /**
     * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
     * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
     * at the beginning of a line
     * l is of the form l = 2*k, k a non negative integer
     */
    private static final int ZZ_LEXSTATE[] = {
            0, 0, 1, 1, 2, 2
    };

    /**
     * Translates characters to character classes
     */
    private static final String ZZ_CMAP_PACKED =
            "\11\0\1\3\1\2\1\71\1\72\1\1\22\0\1\3\1\60\1\17" +
                    "\2\0\1\70\1\62\1\20\1\46\1\47\1\65\1\64\1\56\1\5" +
                    "\1\16\1\66\1\13\11\12\1\55\1\54\1\4\1\57\1\6\2\0" +
                    "\6\15\21\7\1\14\2\7\1\52\1\21\1\53\1\67\1\11\1\0" +
                    "\1\25\1\41\1\22\1\35\1\32\1\45\1\37\1\43\1\34\1\7" +
                    "\1\42\1\31\1\36\1\24\1\23\2\7\1\30\1\27\1\26\1\44" +
                    "\1\10\1\33\1\14\1\40\1\7\1\50\1\63\1\51\1\61\6\0" +
                    "\1\71\u1fa2\0\1\71\1\71\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\udfe6\0";

    /**
     * Translates characters to character classes
     */
    private static final char[] ZZ_CMAP = zzUnpackCMap(ZZ_CMAP_PACKED);
    private static final String ZZ_ACTION_PACKED_0 =
            "\3\0\1\1\2\2\1\3\1\4\1\5\1\6\1\2" +
                    "\2\7\1\10\1\11\1\12\17\6\1\13\1\14\1\15" +
                    "\1\16\1\17\1\20\1\21\1\22\1\23\1\24\1\25" +
                    "\1\26\1\27\1\30\1\31\1\32\1\33\1\34\1\35" +
                    "\1\36\2\37\1\40\2\1\2\41\1\1\1\0\1\42" +
                    "\1\2\1\43\1\6\1\44\1\45\4\6\1\46\15\6" +
                    "\1\47\1\50\6\6\1\51\1\52\1\53\1\54\1\55" +
                    "\1\56\1\57\1\60\1\61\1\62\1\63\1\64\1\65" +
                    "\1\66\1\67\10\56\1\0\4\6\1\70\17\6\1\71" +
                    "\7\6\1\72\1\73\1\74\1\75\1\76\1\77\1\100" +
                    "\1\101\1\0\1\102\2\6\1\103\1\104\2\6\1\105" +
                    "\3\6\1\106\1\107\2\6\1\110\1\111\3\6\1\112" +
                    "\3\6\1\113\1\114\1\115\3\6\1\0\3\6\1\116" +
                    "\5\6\1\117\2\6\1\120\1\121\1\6\1\122\1\123" +
                    "\1\6\1\124\1\6\1\125\1\126\1\127\1\6\1\130" +
                    "\3\6\1\131\3\6\1\132\1\6\1\133\1\6\1\134" +
                    "\2\6\1\135\1\136\2\6\1\137";
    /**
     * Translates DFA states to action switch labels.
     */
    private static final int[] ZZ_ACTION = zzUnpackAction();
    private static final String ZZ_ROWMAP_PACKED_0 =
            "\0\0\0\73\0\166\0\261\0\354\0\261\0\u0127\0\u0162" +
                    "\0\u019d\0\u01d8\0\u0213\0\u024e\0\u0289\0\u02c4\0\261\0\261" +
                    "\0\u02ff\0\u033a\0\u0375\0\u03b0\0\u03eb\0\u0426\0\u0461\0\u049c" +
                    "\0\u04d7\0\u0512\0\u054d\0\u0588\0\u05c3\0\u05fe\0\u0639\0\261" +
                    "\0\261\0\261\0\261\0\261\0\261\0\261\0\u0674\0\261" +
                    "\0\261\0\u06af\0\261\0\u06ea\0\u0725\0\261\0\261\0\261" +
                    "\0\261\0\261\0\u0760\0\u079b\0\261\0\261\0\u07d6\0\u0811" +
                    "\0\u084c\0\261\0\u0887\0\u08c2\0\261\0\u08fd\0\261\0\u0938" +
                    "\0\u02c4\0\u0973\0\u09ae\0\u09e9\0\u0a24\0\u0a5f\0\u01d8\0\u0a9a" +
                    "\0\u0ad5\0\u0b10\0\u0b4b\0\u0b86\0\u0bc1\0\u0bfc\0\u0c37\0\u0c72" +
                    "\0\u0cad\0\u0ce8\0\u0d23\0\u0d5e\0\u01d8\0\u01d8\0\u0d99\0\u0dd4" +
                    "\0\u0e0f\0\u0e4a\0\u0e85\0\u0ec0\0\261\0\261\0\261\0\261" +
                    "\0\261\0\261\0\261\0\261\0\261\0\261\0\261\0\261" +
                    "\0\261\0\261\0\261\0\u0efb\0\u0f36\0\u0f71\0\u0fac\0\u0fe7" +
                    "\0\u1022\0\u105d\0\u1098\0\u10d3\0\u110e\0\u1149\0\u1184\0\u11bf" +
                    "\0\u01d8\0\u11fa\0\u1235\0\u1270\0\u12ab\0\u12e6\0\u1321\0\u135c" +
                    "\0\u1397\0\u13d2\0\u140d\0\u1448\0\u1483\0\u14be\0\u14f9\0\u1534" +
                    "\0\u01d8\0\u156f\0\u15aa\0\u15e5\0\u1620\0\u165b\0\u1696\0\u16d1" +
                    "\0\261\0\261\0\261\0\261\0\261\0\261\0\261\0\261" +
                    "\0\u170c\0\u01d8\0\u1747\0\u1782\0\u01d8\0\u01d8\0\u17bd\0\u17f8" +
                    "\0\u01d8\0\u1833\0\u186e\0\u18a9\0\u01d8\0\u01d8\0\u18e4\0\u191f" +
                    "\0\u01d8\0\u01d8\0\u195a\0\u1995\0\u19d0\0\u01d8\0\u1a0b\0\u1a46" +
                    "\0\u1a81\0\u01d8\0\u01d8\0\u01d8\0\u1abc\0\u1af7\0\u1b32\0\u1b6d" +
                    "\0\u1ba8\0\u1be3\0\u1c1e\0\u01d8\0\u1c59\0\u1c94\0\u1ccf\0\u1d0a" +
                    "\0\u1d45\0\u01d8\0\u1d80\0\u1dbb\0\u01d8\0\u01d8\0\u1df6\0\u01d8" +
                    "\0\u01d8\0\u1e31\0\u01d8\0\u1e6c\0\u01d8\0\u01d8\0\u01d8\0\u1ea7" +
                    "\0\u01d8\0\u1ee2\0\u1f1d\0\u1f58\0\u01d8\0\u1f93\0\u1fce\0\u2009" +
                    "\0\u01d8\0\u2044\0\u01d8\0\u207f\0\u01d8\0\u20ba\0\u20f5\0\u01d8" +
                    "\0\u01d8\0\u2130\0\u216b\0\u01d8";
    /**
     * Translates a state to a row index in the transition table
     */
    private static final int[] ZZ_ROWMAP = zzUnpackRowMap();
    private static final String ZZ_TRANS_PACKED_0 =
            "\1\4\1\5\2\6\1\7\1\10\1\11\1\12\1\13" +
                    "\1\4\1\14\1\15\2\12\1\16\1\17\1\20\1\4" +
                    "\1\21\1\22\1\12\1\23\1\24\1\25\1\26\1\27" +
                    "\1\30\1\31\1\32\1\33\1\34\1\35\1\12\1\36" +
                    "\3\12\1\37\1\40\1\41\1\42\1\43\1\44\1\45" +
                    "\1\46\1\47\1\50\1\51\1\52\1\53\1\54\1\55" +
                    "\1\56\1\57\1\60\1\61\1\62\1\4\1\6\1\63" +
                    "\1\64\1\65\14\63\1\66\1\63\1\67\51\63\1\70" +
                    "\1\71\1\72\15\70\1\4\1\73\51\70\75\0\1\6" +
                    "\75\0\1\74\51\0\1\75\20\0\1\76\144\0\1\77" +
                    "\22\0\7\12\4\0\24\12\34\0\7\12\4\0\1\12" +
                    "\1\100\22\12\37\0\2\14\2\0\1\101\66\0\2\14" +
                    "\1\102\1\0\1\101\66\0\2\101\66\0\7\12\4\0" +
                    "\1\12\1\103\1\12\1\104\15\12\1\105\2\12\34\0" +
                    "\7\12\4\0\22\12\1\106\1\107\34\0\7\12\4\0" +
                    "\5\12\1\110\1\111\15\12\34\0\7\12\4\0\6\12" +
                    "\1\112\15\12\34\0\7\12\4\0\4\12\1\113\17\12" +
                    "\34\0\7\12\4\0\10\12\1\114\13\12\34\0\7\12" +
                    "\4\0\1\12\1\115\1\12\1\116\20\12\34\0\7\12" +
                    "\4\0\2\12\1\117\4\12\1\120\14\12\34\0\7\12" +
                    "\4\0\6\12\1\121\12\12\1\122\2\12\34\0\7\12" +
                    "\4\0\2\12\1\123\2\12\1\124\15\12\1\125\34\0" +
                    "\7\12\4\0\1\12\1\126\22\12\34\0\7\12\4\0" +
                    "\3\12\1\127\20\12\34\0\7\12\4\0\1\12\1\130" +
                    "\22\12\34\0\7\12\4\0\1\12\1\131\4\12\1\132" +
                    "\15\12\34\0\7\12\4\0\3\12\1\133\16\12\1\134" +
                    "\1\12\102\0\1\135\1\0\1\136\72\0\1\137\75\0" +
                    "\1\140\73\0\1\141\7\0\1\63\2\0\14\63\1\0" +
                    "\1\63\1\0\51\63\2\0\1\65\70\0\1\142\2\0" +
                    "\14\142\1\143\1\144\1\145\2\142\1\146\1\142\1\147" +
                    "\1\142\1\150\10\142\1\151\3\142\1\152\23\142\22\0" +
                    "\1\153\54\0\1\72\70\0\1\142\2\0\14\142\1\154" +
                    "\1\155\1\156\2\142\1\157\1\142\1\160\1\142\1\161" +
                    "\10\142\1\162\3\142\1\163\23\142\7\0\1\164\65\0" +
                    "\1\76\1\5\1\6\70\76\7\0\7\12\4\0\12\12" +
                    "\1\165\11\12\37\0\2\102\1\0\1\102\4\0\1\102" +
                    "\2\0\1\102\4\0\1\102\2\0\1\102\3\0\1\102" +
                    "\3\0\1\102\34\0\7\12\4\0\2\12\1\166\21\12" +
                    "\34\0\7\12\4\0\5\12\1\167\16\12\34\0\7\12" +
                    "\4\0\3\12\1\170\20\12\34\0\7\12\4\0\4\12" +
                    "\1\171\17\12\34\0\7\12\4\0\5\12\1\172\16\12" +
                    "\34\0\7\12\4\0\6\12\1\173\15\12\34\0\7\12" +
                    "\4\0\22\12\1\174\1\12\34\0\7\12\4\0\6\12" +
                    "\1\175\15\12\34\0\7\12\4\0\3\12\1\176\1\177" +
                    "\2\12\1\200\14\12\34\0\7\12\4\0\2\12\1\201" +
                    "\21\12\34\0\7\12\4\0\4\12\1\202\12\12\1\203" +
                    "\4\12\34\0\1\12\1\204\5\12\4\0\13\12\1\205" +
                    "\10\12\34\0\7\12\4\0\5\12\1\206\16\12\34\0" +
                    "\7\12\4\0\12\12\1\207\11\12\34\0\7\12\4\0" +
                    "\12\12\1\210\11\12\34\0\7\12\4\0\4\12\1\211" +
                    "\17\12\34\0\1\12\1\212\5\12\4\0\24\12\34\0" +
                    "\7\12\4\0\12\12\1\213\11\12\34\0\7\12\4\0" +
                    "\4\12\1\214\17\12\34\0\7\12\4\0\1\12\1\215" +
                    "\22\12\34\0\7\12\4\0\10\12\1\216\13\12\34\0" +
                    "\7\12\4\0\7\12\1\217\14\12\34\0\7\12\4\0" +
                    "\2\12\1\220\21\12\45\0\1\221\72\0\1\222\72\0" +
                    "\1\223\72\0\1\224\72\0\1\225\72\0\1\226\72\0" +
                    "\1\227\72\0\1\230\52\0\5\164\1\231\65\164\7\0" +
                    "\7\12\4\0\13\12\1\232\10\12\34\0\7\12\4\0" +
                    "\1\233\3\12\1\234\17\12\34\0\7\12\4\0\10\12" +
                    "\1\235\13\12\34\0\7\12\4\0\6\12\1\236\15\12" +
                    "\34\0\7\12\4\0\12\12\1\237\11\12\34\0\7\12" +
                    "\4\0\3\12\1\240\20\12\34\0\7\12\4\0\10\12" +
                    "\1\241\13\12\34\0\7\12\4\0\7\12\1\242\2\12" +
                    "\1\243\7\12\1\244\1\12\34\0\7\12\4\0\7\12" +
                    "\1\245\3\12\1\246\10\12\34\0\7\12\4\0\22\12" +
                    "\1\247\1\12\34\0\7\12\4\0\10\12\1\250\13\12" +
                    "\34\0\7\12\4\0\15\12\1\251\6\12\34\0\7\12" +
                    "\4\0\10\12\1\252\13\12\34\0\7\12\4\0\10\12" +
                    "\1\253\13\12\34\0\7\12\4\0\12\12\1\254\11\12" +
                    "\34\0\7\12\4\0\1\255\23\12\34\0\7\12\4\0" +
                    "\10\12\1\256\13\12\34\0\7\12\4\0\4\12\1\257" +
                    "\17\12\34\0\7\12\4\0\7\12\1\260\14\12\34\0" +
                    "\7\12\4\0\1\12\1\261\22\12\34\0\7\12\4\0" +
                    "\2\12\1\262\21\12\34\0\7\12\4\0\1\12\1\263" +
                    "\22\12\34\0\7\12\4\0\7\12\1\264\14\12\34\0" +
                    "\7\12\4\0\3\12\1\265\20\12\34\0\7\12\4\0" +
                    "\5\12\1\266\16\12\34\0\7\12\4\0\1\267\23\12" +
                    "\25\0\5\164\1\270\65\164\7\0\7\12\4\0\3\12" +
                    "\1\271\20\12\34\0\7\12\4\0\12\12\1\272\11\12" +
                    "\34\0\7\12\4\0\15\12\1\273\6\12\34\0\7\12" +
                    "\4\0\16\12\1\274\5\12\34\0\7\12\4\0\10\12" +
                    "\1\275\13\12\34\0\7\12\4\0\2\12\1\276\21\12" +
                    "\34\0\7\12\4\0\1\277\23\12\34\0\7\12\4\0" +
                    "\6\12\1\300\15\12\34\0\7\12\4\0\3\12\1\301" +
                    "\20\12\34\0\7\12\4\0\7\12\1\302\14\12\34\0" +
                    "\7\12\4\0\6\12\1\303\15\12\34\0\7\12\4\0" +
                    "\3\12\1\304\20\12\34\0\7\12\4\0\10\12\1\305" +
                    "\13\12\34\0\7\12\4\0\10\12\1\306\13\12\34\0" +
                    "\7\12\4\0\12\12\1\307\11\12\34\0\7\12\4\0" +
                    "\20\12\1\310\3\12\34\0\7\12\4\0\10\12\1\311" +
                    "\13\12\34\0\7\12\4\0\4\12\1\312\17\12\25\0" +
                    "\5\164\1\270\1\6\64\164\7\0\7\12\4\0\4\12" +
                    "\1\313\17\12\34\0\7\12\4\0\2\12\1\314\21\12" +
                    "\34\0\7\12\4\0\2\12\1\315\21\12\34\0\7\12" +
                    "\4\0\2\12\1\316\21\12\34\0\7\12\4\0\15\12" +
                    "\1\317\6\12\34\0\7\12\4\0\4\12\1\320\17\12" +
                    "\34\0\7\12\4\0\2\12\1\321\21\12\34\0\7\12" +
                    "\4\0\5\12\1\322\16\12\34\0\7\12\4\0\1\12" +
                    "\1\323\22\12\34\0\7\12\4\0\5\12\1\324\16\12" +
                    "\34\0\7\12\4\0\13\12\1\325\10\12\34\0\7\12" +
                    "\4\0\12\12\1\326\11\12\34\0\7\12\4\0\22\12" +
                    "\1\327\1\12\34\0\7\12\4\0\22\12\1\330\1\12" +
                    "\34\0\7\12\4\0\10\12\1\331\13\12\34\0\7\12" +
                    "\4\0\2\12\1\332\21\12\34\0\7\12\4\0\10\12" +
                    "\1\333\13\12\34\0\7\12\4\0\1\12\1\334\22\12" +
                    "\34\0\7\12\4\0\10\12\1\335\13\12\34\0\7\12" +
                    "\4\0\6\12\1\336\15\12\34\0\7\12\4\0\14\12" +
                    "\1\337\7\12\34\0\7\12\4\0\2\12\1\340\21\12" +
                    "\34\0\7\12\4\0\10\12\1\341\13\12\34\0\7\12" +
                    "\4\0\10\12\1\342\13\12\34\0\7\12\4\0\2\12" +
                    "\1\343\21\12\34\0\7\12\4\0\4\12\1\344\17\12" +
                    "\25\0";
    /**
     * The transition table of the DFA
     */
    private static final int[] ZZ_TRANS = zzUnpackTrans();
    /* error codes */
    private static final int ZZ_UNKNOWN_ERROR = 0;
    private static final int ZZ_NO_MATCH = 1;
    private static final int ZZ_PUSHBACK_2BIG = 2;
    /* error messages for the codes above */
    private static final String ZZ_ERROR_MSG[] = {
            "Unknown internal scanner error",
            "Error: could not match input",
            "Error: pushback value was too large"
    };
    private static final String ZZ_ATTRIBUTE_PACKED_0 =
            "\3\0\1\11\1\1\1\11\10\1\2\11\17\1\7\11" +
                    "\1\1\2\11\1\1\1\11\2\1\5\11\2\1\2\11" +
                    "\3\1\1\11\1\1\1\0\1\11\1\1\1\11\35\1" +
                    "\17\11\10\1\1\0\34\1\10\11\1\0\36\1\1\0" +
                    "\54\1";
    /**
     * ZZ_ATTRIBUTE[aState] contains the attributes of state <code>aState</code>
     */
    private static final int[] ZZ_ATTRIBUTE = zzUnpackAttribute();
    /* user code: */
    StringBuilder string = new StringBuilder();
    boolean inAssign = false;
    /**
     * the input device
     */
    private java.io.Reader zzReader;
    /**
     * the current state of the DFA
     */
    private int zzState;
    /**
     * the current lexical state
     */
    private int zzLexicalState = YYINITIAL;
    /**
     * this buffer contains the current text to be matched and is
     * the source of the yytext() string
     */
    private char zzBuffer[] = new char[ZZ_BUFFERSIZE];
    /**
     * the textposition at the last accepting state
     */
    private int zzMarkedPos;
    /**
     * the current text position in the buffer
     */
    private int zzCurrentPos;
    /**
     * startRead marks the beginning of the yytext() string in the buffer
     */
    private int zzStartRead;
    /**
     * endRead marks the last character in the buffer, that has been read
     * from input
     */
    private int zzEndRead;
    /**
     * number of newlines encountered up to the start of the matched text
     */
    private int yyline;
    /**
     * the number of characters up to the start of the matched text
     */
    private int yychar;
    /**
     * the number of characters from the last newline up to the start of the
     * matched text
     */
    private int yycolumn;
    /**
     * zzAtBOL == true <=> the scanner is currently at the beginning of a line
     */
    private boolean zzAtBOL = true;
    /**
     * zzAtEOF == true <=> the scanner is at the EOF
     */
    private boolean zzAtEOF;
    /**
     * denotes if the user-EOF-code has already been executed
     */
    private boolean zzEOFDone;
    /**
     * The number of occupied positions in zzBuffer beyond zzEndRead.
     * When a lead/high surrogate has been read from the input stream
     * into the final zzBuffer position, this will have a value of 1;
     * otherwise, it will have a value of 0.
     */
    private int zzFinalHighSurrogate = 0;

    /**
     * Creates a new scanner
     *
     * @param in the java.io.Reader to read input from.
     */
    public FlexScanner(java.io.Reader in) {
        this.zzReader = in;
    }

    private static int[] zzUnpackAction() {
        int[] result = new int[228];
        int offset = 0;
        offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
        return result;
    }

    private static int zzUnpackAction(String packed, int offset, int[] result) {
        int i = 0;       /* index in packed string  */
        int j = offset;  /* index in unpacked array */
        int l = packed.length();
        while (i < l) {
            int count = packed.charAt(i++);
            int value = packed.charAt(i++);
            do result[j++] = value; while (--count > 0);
        }
        return j;
    }

    private static int[] zzUnpackRowMap() {
        int[] result = new int[228];
        int offset = 0;
        offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
        return result;
    }

    private static int zzUnpackRowMap(String packed, int offset, int[] result) {
        int i = 0;  /* index in packed string  */
        int j = offset;  /* index in unpacked array */
        int l = packed.length();
        while (i < l) {
            int high = packed.charAt(i++) << 16;
            result[j++] = high | packed.charAt(i++);
        }
        return j;
    }

    private static int[] zzUnpackTrans() {
        int[] result = new int[8614];
        int offset = 0;
        offset = zzUnpackTrans(ZZ_TRANS_PACKED_0, offset, result);
        return result;
    }

    private static int zzUnpackTrans(String packed, int offset, int[] result) {
        int i = 0;       /* index in packed string  */
        int j = offset;  /* index in unpacked array */
        int l = packed.length();
        while (i < l) {
            int count = packed.charAt(i++);
            int value = packed.charAt(i++);
            value--;
            do result[j++] = value; while (--count > 0);
        }
        return j;
    }

    private static int[] zzUnpackAttribute() {
        int[] result = new int[228];
        int offset = 0;
        offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
        return result;
    }

    private static int zzUnpackAttribute(String packed, int offset, int[] result) {
        int i = 0;       /* index in packed string  */
        int j = offset;  /* index in unpacked array */
        int l = packed.length();
        while (i < l) {
            int count = packed.charAt(i++);
            int value = packed.charAt(i++);
            do result[j++] = value; while (--count > 0);
        }
        return j;
    }

    /**
     * Unpacks the compressed character translation table.
     *
     * @param packed the packed character translation table
     * @return the unpacked character translation table
     */
    private static char[] zzUnpackCMap(String packed) {
        char[] map = new char[0x110000];
        int i = 0;  /* index in packed string  */
        int j = 0;  /* index in unpacked array */
        while (i < 182) {
            int count = packed.charAt(i++);
            char value = packed.charAt(i++);
            do map[j++] = value; while (--count > 0);
        }
        return map;
    }

    public int getCurrentLineNumber() {
        return yyline;
    }

    public int getCurrentCharNumber() {
        return yychar;
    }

    public int getCurrentColumnNumber() {
        return yycolumn;
    }

    private long parseLong(int start, int end, int radix) {
        long result = 0;
        long digit;

        for (int i = start; i < end; i++) {
            digit = Character.digit(yycharat(i), radix);
            result = Math.multiplyExact(result, radix);
            result = Math.addExact(result, digit);
        }

        return result;
    }

    /**
     * Refills the input buffer.
   *
   * @return      <code>false</code>, iff there was new input.
     *
     * @exception java.io.IOException  if any I/O-Error occurs
     */
    private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
        if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
            zzFinalHighSurrogate = 0;
            System.arraycopy(zzBuffer, zzStartRead,
                    zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
            zzEndRead-= zzStartRead;
      zzCurrentPos -= zzStartRead;
            zzMarkedPos -= zzStartRead;
            zzStartRead = 0;
        }

    /* is the buffer big enough? */
        if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate) {
      /* if not: blow it up */
            char newBuffer[] = new char[zzBuffer.length * 2];
            System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
            zzBuffer = newBuffer;
            zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
        int requested = zzBuffer.length - zzEndRead;
        int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      throw new java.io.IOException("Reader returned 0 characters. See JFlex examples for workaround.");
    }
    if (numRead > 0) {
        zzEndRead += numRead;
      /* If numRead == requested, we might have requested to few chars to
         encode a full Unicode character. We assume that a Reader would
         otherwise never return half characters. */
        if (numRead == requested) {
        if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
            --zzEndRead;
            zzFinalHighSurrogate = 1;
        }
        }
      /* potentially more input available */
        return false;
    }

    /* numRead < 0 ==> end of stream */
        return true;
    }


    /**
     * Closes the input stream.
     */
    public final void yyclose() throws java.io.IOException {
        zzAtEOF = true;            /* indicate end of file */
        zzEndRead = zzStartRead;  /* invalidate buffer    */

        if (zzReader != null)
            zzReader.close();
    }


    /**
     * Resets the scanner to read from a new input stream.
     * Does not close the old reader.
     * <p>
     * All internal variables are reset, the old input stream
     * <b>cannot</b> be reused (internal buffer is discarded and lost).
     * Lexical state is set to <tt>ZZ_INITIAL</tt>.
     * <p>
     * Internal scan buffer is resized down to its initial length, if it has grown.
     *
     * @param reader the new input stream
     */
    public final void yyreset(java.io.Reader reader) {
        zzReader = reader;
        zzAtBOL = true;
        zzAtEOF = false;
        zzEOFDone = false;
        zzEndRead = zzStartRead = 0;
        zzCurrentPos = zzMarkedPos = 0;
        zzFinalHighSurrogate = 0;
        yyline = yychar = yycolumn = 0;
        zzLexicalState = YYINITIAL;
        if (zzBuffer.length > ZZ_BUFFERSIZE)
            zzBuffer = new char[ZZ_BUFFERSIZE];
    }


    /**
     * Returns the current lexical state.
     */
    public final int yystate() {
        return zzLexicalState;
    }


    /**
     * Enters a new lexical state
     *
     * @param newState the new lexical state
     */
    public final void yybegin(int newState) {
        zzLexicalState = newState;
    }


    /**
     * Returns the text matched by the current regular expression.
     */
    public final String yytext() {
        return new String(zzBuffer, zzStartRead, zzMarkedPos - zzStartRead);
    }


    /**
     * Returns the character at position <tt>pos</tt> from the
     * matched text.
     *
     * It is equivalent to yytext().charAt(pos), but faster
     *
     * @param pos the position of the character to fetch.
     *            A value from 0 to yylength()-1.
     *
     * @return the character at position pos
     */
    public final char yycharat(int pos) {
        return zzBuffer[zzStartRead + pos];
    }


    /**
     * Returns the length of the matched text region.
     */
    public final int yylength() {
        return zzMarkedPos - zzStartRead;
    }


    /**
     * Reports an error that occured while scanning.
     *
     * In a wellformed scanner (no or only correct usage of
     * yypushback(int) and a match-all fallback rule) this method
     * will only be called with things that "Can't Possibly Happen".
     * If this method is called, something is seriously wrong
     * (e.g. a JFlex bug producing a faulty scanner etc.).
     *
     * Usual syntax/scanner level error handling should be done
     * in error fallback rules.
     *
     * @param   errorCode  the code of the errormessage to display
     */
    private void zzScanError(int errorCode) {
        String message;
        try {
            message = ZZ_ERROR_MSG[errorCode];
        } catch (ArrayIndexOutOfBoundsException e) {
            message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
        }

        throw new Error(message);
    }


    /**
     * Pushes the specified amount of characters back into the input stream.
     *
     * They will be read again by then next call of the scanning method
     *
     * @param number  the number of characters to be read again.
     *                This number must not be greater than yylength()!
     */
    public void yypushback(int number) {
        if (number > yylength())
            zzScanError(ZZ_PUSHBACK_2BIG);

        zzMarkedPos -= number;
    }


    /**
     * Contains user EOF-code, which will be executed exactly once,
     * when the end of file is reached
     */
    private void zzDoEOF() throws java.io.IOException {
        if (!zzEOFDone) {
            zzEOFDone = true;
            yyclose();
        }
    }


    /**
     * Resumes scanning until the next regular expression is matched,
     * the end of input is encountered or an I/O-Error occurs.
     *
     * @return the next token
     * @exception java.io.IOException  if any I/O-Error occurs
     */
    public Symbol next_token() throws java.io.IOException {
        int zzInput;
        int zzAction;

        // cached fields:
        int zzCurrentPosL;
        int zzMarkedPosL;
        int zzEndReadL = zzEndRead;
        char[] zzBufferL = zzBuffer;
        char[] zzCMapL = ZZ_CMAP;

        int[] zzTransL = ZZ_TRANS;
        int[] zzRowMapL = ZZ_ROWMAP;
        int[] zzAttrL = ZZ_ATTRIBUTE;

        while (true) {
            zzMarkedPosL = zzMarkedPos;

            boolean zzR = false;
            int zzCh;
            int zzCharCount;
            for (zzCurrentPosL = zzStartRead;
                 zzCurrentPosL < zzMarkedPosL;
                 zzCurrentPosL += zzCharCount) {
                zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
                zzCharCount = Character.charCount(zzCh);
                switch (zzCh) {
                    case '\u000B':
                    case '\u000C':
                    case '\u0085':
                    case '\u2028':
                    case '\u2029':
                        yyline++;
                        yycolumn = 0;
                        zzR = false;
                        break;
                    case '\r':
                        yyline++;
                        yycolumn = 0;
                        zzR = true;
                        break;
                    case '\n':
                        if (zzR)
                            zzR = false;
                        else {
                            yyline++;
                            yycolumn = 0;
                        }
                        break;
                    default:
                        zzR = false;
                        yycolumn += zzCharCount;
                }
            }

            if (zzR) {
                // peek one character ahead if it is \n (if we have counted one line too much)
                boolean zzPeek;
                if (zzMarkedPosL < zzEndReadL)
                    zzPeek = zzBufferL[zzMarkedPosL] == '\n';
                else if (zzAtEOF)
                    zzPeek = false;
                else {
                    boolean eof = zzRefill();
                    zzEndReadL = zzEndRead;
                    zzMarkedPosL = zzMarkedPos;
                    zzBufferL = zzBuffer;
                    if (eof)
                        zzPeek = false;
                    else
                        zzPeek = zzBufferL[zzMarkedPosL] == '\n';
                }
                if (zzPeek) yyline--;
            }
            zzAction = -1;

            zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

            zzState = ZZ_LEXSTATE[zzLexicalState];

            // set up zzAction for empty match case:
            int zzAttributes = zzAttrL[zzState];
            if ((zzAttributes & 1) == 1) {
                zzAction = zzState;
            }


            zzForAction:
            {
                while (true) {

                    if (zzCurrentPosL < zzEndReadL) {
                        zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
                        zzCurrentPosL += Character.charCount(zzInput);
                    } else if (zzAtEOF) {
                        zzInput = YYEOF;
                        break zzForAction;
                    } else {
                        // store back cached positions
                        zzCurrentPos = zzCurrentPosL;
                        zzMarkedPos = zzMarkedPosL;
                        boolean eof = zzRefill();
                        // get translated positions and possibly new buffer
                        zzCurrentPosL = zzCurrentPos;
                        zzMarkedPosL = zzMarkedPos;
                        zzBufferL = zzBuffer;
                        zzEndReadL = zzEndRead;
                        if (eof) {
                            zzInput = YYEOF;
                            break zzForAction;
                        } else {
                            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
                            zzCurrentPosL += Character.charCount(zzInput);
                        }
                    }
                    int zzNext = zzTransL[zzRowMapL[zzState] + zzCMapL[zzInput]];
                    if (zzNext == -1) break zzForAction;
                    zzState = zzNext;

                    zzAttributes = zzAttrL[zzState];
                    if ((zzAttributes & 1) == 1) {
                        zzAction = zzState;
                        zzMarkedPosL = zzCurrentPosL;
                        if ((zzAttributes & 8) == 8) break zzForAction;
                    }

                }
            }

            // store back cached position
            zzMarkedPos = zzMarkedPosL;

            if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
                zzAtEOF = true;
                zzDoEOF();
                {
                    return new Symbol(EOF);
                }
            } else {
                switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1: {
              throw new RuntimeException("Illegal character \"" + yytext() +
                      "\" at line " + yyline + ", column " + yycolumn);
          }
                    case 96:
                        break;
                    case 2: {
                    }
                    case 97:
                        break;
                    case 3: {
                        if (inAssign) {
                            return new Symbol(LT_IN_ASSIGN);
                        } else {
                            return new Symbol(LT);
                        }
                    }
                    case 98:
                        break;
                    case 4: {
                        return new Symbol(MINUS);
                    }
                    case 99:
                        break;
                    case 5: {
                        if (inAssign) {
                            inAssign = false;
                            return new Symbol(GT_IN_ASSIGN);
                        } else {
                            return new Symbol(GT);
                        }
                    }
                    case 100:
                        break;
                    case 6: {
                        return new Symbol(IDENTIFIER, yytext());
                    }
                    case 101:
                        break;
                    case 7: {
                        return new Symbol(CONSTANT, new Long(yytext().substring(0, yylength())));
                    }
                    case 102:
                        break;
                    case 8: {
                        return new Symbol(DOT);
                    }
                    case 103:
                        break;
                    case 9: {
                        yybegin(STRING);
                        string.setLength(0);
                    }
                    case 104:
                        break;
                    case 10: {
                        yybegin(CHARLITERAL);
                    }
                    case 105:
                        break;
                    case 11: {
                        return new Symbol(LPAREN);
                    }
                    case 106:
                        break;
                    case 12: {
                        return new Symbol(RPAREN);
                    }
                    case 107:
                        break;
                    case 13: {
                        return new Symbol(LBRACE);
                    }
                    case 108:
                        break;
                    case 14: {
                        return new Symbol(RBRACE);
                    }
                    case 109:
                        break;
                    case 15: {
                        return new Symbol(LBRACKET);
                    }
                    case 110:
                        break;
                    case 16: {
                        return new Symbol(RBRACKET);
                    }
                    case 111:
                        break;
                    case 17: {
                        inAssign = false;
                        return new Symbol(SEMICOLON);
                    }
                    case 112:
                        break;
                    case 18: {
                        return new Symbol(COLON);
                    }
                    case 113:
                        break;
                    case 19: {
                        return new Symbol(COMMA);
                    }
                    case 114:
                        break;
                    case 20: {
                        return new Symbol(EQCOMP);
                    }
                    case 115:
                        break;
                    case 21: {
                        return new Symbol(NOT);
                    }
                    case 116:
                        break;
                    case 22: {
                        return new Symbol(COMP);
                    }
                    case 117:
                        break;
                    case 23: {
                        return new Symbol(AND);
                    }
                    case 118:
                        break;
                    case 24: {
                        return new Symbol(OR);
                    }
                    case 119:
                        break;
                    case 25: {
                        return new Symbol(PLUS);
                    }
                    case 120:
                        break;
                    case 26: {
                        return new Symbol(MUL);
                    }
                    case 121:
                        break;
                    case 27: {
                        return new Symbol(DIV);
                    }
                    case 122:
                        break;
                    case 28: {
                        return new Symbol(XOR);
                    }
                    case 123:
                        break;
                    case 29: {
                        return new Symbol(MOD);
                    }
                    case 124:
                        break;
                    case 30: {
                        string.append(yytext());
                    }
                    case 125:
                        break;
                    case 31: {
                        throw new RuntimeException("Unterminated string at end of line");
                    }
                    case 126:
                        break;
                    case 32: {
                        yybegin(YYINITIAL);
                        return new Symbol(CONSTANT, string.toString());
                    }
                    case 127:
                        break;
                    case 33: {
                        throw new RuntimeException("Unterminated character literal at end of line");
                    }
                    case 128:
                        break;
                    case 34: {
                        return new Symbol(LTEQ);
                    }
                    case 129:
                        break;
                    case 35: {
                        return new Symbol(GTEQ);
                    }
                    case 130:
                        break;
                    case 36: {
                        return new Symbol(CONSTANT, new Float(yytext().substring(0, yylength())));
                    }
                    case 131:
                        break;
                    case 37: {
                        return new Symbol(CONSTANT, new Long(parseLong(2, yylength(), 16)));
                    }
                    case 132:
                        break;
                    case 38: {
                        return new Symbol(OF);
                    }
                    case 133:
                        break;
                    case 39: {
                        return new Symbol(IF);
                    }
                    case 134:
                        break;
                    case 40: {
                        return new Symbol(DO);
                    }
                    case 135:
                        break;
                    case 41: {
                        return new Symbol(DOUBLECOLON);
                    }
                    case 136:
                        break;
                    case 42: {
                        return new Symbol(EQ);
                    }
                    case 137:
                        break;
                    case 43: {
                        return new Symbol(NOTEQ);
                    }
                    case 138:
                        break;
                    case 44: {
                        return new Symbol(LOGICALAND);
                    }
                    case 139:
                        break;
                    case 45: {
                        return new Symbol(LOGICALOR);
                    }
                    case 140:
                        break;
                    case 46: {
                        throw new RuntimeException("Illegal escape sequence \"" + yytext() + "\"");
                    }
                    case 141:
                        break;
                    case 47: {
                        string.append('\"');
                    }
                    case 142:
                        break;
                    case 48: {
                        string.append('\'');
                    }
                    case 143:
                        break;
                    case 49: {
                        string.append('\\');
                    }
                    case 144:
                        break;
                    case 50: {
                        string.append('\n');
                    }
                    case 145:
                        break;
                    case 51: {
                        string.append('\t');
                    }
                    case 146:
                        break;
                    case 52: {
                        string.append('\r');
                    }
                    case 147:
                        break;
                    case 53: {
                        string.append('\b');
                    }
                    case 148:
                        break;
                    case 54: {
                        string.append('\f');
                    }
                    case 149:
                        break;
                    case 55: {
                        yybegin(YYINITIAL);
                        return new Symbol(CONSTANT, yytext().charAt(0));
                    }
                    case 150:
                        break;
                    case 56: {
                        return new Symbol(OUT);
                    }
                    case 151:
                        break;
                    case 57: {
                        return new Symbol(TYPE, "int");
                    }
                    case 152:
                        break;
                    case 58: {
                        yybegin(YYINITIAL);
                        return new Symbol(CONSTANT, '\"');
                    }
                    case 153:
                        break;
                    case 59: {
                        yybegin(YYINITIAL);
                        return new Symbol(CONSTANT, '\'');
                    }
                    case 154:
                        break;
                    case 60: {
                        yybegin(YYINITIAL);
                        return new Symbol(CONSTANT, '\\');
                    }
                    case 155:
                        break;
                    case 61: {
                        yybegin(YYINITIAL);
                        return new Symbol(CONSTANT, '\n');
                    }
                    case 156:
                        break;
                    case 62: {
                        yybegin(YYINITIAL);
                        return new Symbol(CONSTANT, '\t');
                    }
                    case 157:
                        break;
                    case 63: {
                        yybegin(YYINITIAL);
                        return new Symbol(CONSTANT, '\r');
                    }
                    case 158:
                        break;
                    case 64: {
                        yybegin(YYINITIAL);
                        return new Symbol(CONSTANT, '\b');
                    }
                    case 159:
                        break;
                    case 65: {
                        yybegin(YYINITIAL);
                        return new Symbol(CONSTANT, '\f');
                    }
                    case 160:
                        break;
                    case 66: {
                        return new Symbol(VOID);
                    }
                    case 161:
                        break;
                    case 67: {
                        return new Symbol(CASE);
                    }
                    case 162:
                        break;
                    case 68: {
                        return new Symbol(TYPE, "char");
                    }
                    case 163:
                        break;
                    case 69: {
                        return new Symbol(CONSTANT, true);
                    }
                    case 164:
                        break;
                    case 70: {
                        return new Symbol(TYPE, "real");
                    }
                    case 165:
                        break;
                    case 71: {
                        return new Symbol(READ);
                    }
                    case 166:
                        break;
                    case 72: {
                        return new Symbol(TYPE, "long");
                    }
                    case 167:
                        break;
                    case 73: {
                        return new Symbol(LATE);
                    }
                    case 168:
                        break;
                    case 74: {
                        return new Symbol(ELSE);
                    }
                    case 169:
                        break;
                    case 75: {
                        return new Symbol(MAIN);
                    }
                    case 170:
                        break;
                    case 76: {
                        return new Symbol(GOTO);
                    }
                    case 171:
                        break;
                    case 77: {
                        return new Symbol(TYPE, "bool");
                    }
                    case 172:
                        break;
                    case 78: {
                        return new Symbol(ARRAY);
                    }
                    case 173:
                        break;
                    case 79: {
                        return new Symbol(LABEL);
                    }
                    case 174:
                        break;
                    case 80: {
                        return new Symbol(WRITE);
                    }
                    case 175:
                        break;
                    case 81: {
                        return new Symbol(WHILE);
                    }
                    case 176:
                        break;
                    case 82: {
                        return new Symbol(BREAK);
                    }
                    case 177:
                        break;
                    case 83: {
                        return new Symbol(CONSTANT, false);
                    }
                    case 178:
                        break;
                    case 84: {
                        return new Symbol(CONCAT);
                    }
                    case 179:
                        break;
                    case 85: {
                        inAssign = true;
                        return new Symbol(ASSIGN);
                    }
                    case 180:
                        break;
                    case 86: {
                        return new Symbol(STRLEN);
                    }
                    case 181:
                        break;
                    case 87: {
                        return new Symbol(TYPE, "string");
                    }
                    case 182:
                        break;
                    case 88: {
                        return new Symbol(RETURN);
                    }
                    case 183:
                        break;
                    case 89: {
                        return new Symbol(ISVOID);
                    }
                    case 184:
                        break;
                    case 90: {
                        return new Symbol(RELEASE);
                    }
                    case 185:
                        break;
                    case 91: {
                        return new Symbol(ENDCASE);
                    }
                    case 186:
                        break;
                    case 92: {
                        return new Symbol(CONTINUE);
                    }
                    case 187:
                        break;
                    case 93: {
                        return new Symbol(FUNCTION);
                    }
                    case 188:
                        break;
                    case 94: { return new Symbol(STRUCTURE);
            }
          case 189: break;
          case 95: 
            { return new Symbol(ENVIRONMENT);
            }
          case 190: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }


}
